(module mixture-test mzscheme
  
  (require (planet "test.ss" ("schematics" "schemeunit.plt" 2)))
  (require "mixture.ss")
  
  (provide mixture-tests)
  
  (define mixture-tests
    (test-suite
     "All tests for mixture"

     (test-case
      "sample-mixture samples from simple distributions"
      (check-equal? (sample-mixture (make-mixture '((1.0 . a)))) 'a)
      (check-equal? (sample-mixture (make-mixture '((0.0 . a) (1.0 . b)))) 'b)
      (check-equal? (sample-mixture (make-mixture '((1.0 . a) (0.0 . b)))) 'a))

     (test-case
      "sample-mixture samples from complex distributions"
      (let* ([the-mixture (make-mixture '((0.2 . a) (0.4 . b) (0.2 . c) (0.2 . d)))]
             [sample-it (lambda (random-number)
                          (sample-mixture the-mixture (lambda () random-number)))])
      (check-equal? (sample-it 0.1) 'd)
      (check-equal? (sample-it 0.3) 'c)
      (check-equal? (sample-it 0.5) 'b)
      (check-equal? (sample-it 0.7) 'b)
      (check-equal? (sample-it 0.9) 'a)
      (check-equal? (sample-it 1.0) 'a)
      (check-equal? (sample-it 0.0) 'd)))
     
     ))
  )
