(module util mzscheme
  
  (require
   (planet "srfi-4-comprehensions.ss" ("wmfarr" "srfi-4-comprehensions.plt" 1))
   (planet "test.ss" ("schematics" "schemeunit.plt" 2))
   (file "matrix.ss")
   (file "vector.ss"))

  (provide (all-defined))

  (define-check (check-m= m1 m2 epsilon)
    (with-check-info
     (['message "Unequal number of rows"])
     (check-eq? (mrows m1) (mrows m2)))
    (with-check-info
     (['message "Unequal number of columns"])
     (check-eq? (mcols m1) (mcols m2)))
    (do-ec
     (:range r (mrows m1))
     (:range c (mcols m1))
     (:let x1  (mref m1 r c))
     (:let x2  (mref m2 r c))
     (with-check-info
      (['message (format "Elements ~a and ~a at row ~a, col ~a not within ~a"
                         x1 x2 r c epsilon)])
      (check <= (abs (- x1 x2)) epsilon))))

  (define-check (check-v= v1 v2 epsilon)
    (with-check-info
     (['message "Unequal length"])
     (check-eq? (vlength v1) (vlength v2)))
    (do-ec
     (:parallel (:range i (vlength v1))
                (:f64vector x1 v1)
                (:f64vector x2 v2))
     (with-check-info
      (['message (format "Elements ~a and ~a at index ~a are not within ~a"
                         x1 x2 i epsilon)])
      (check <= (abs (- x1 x2)) epsilon))))

  
  )
